# -*- Mode: Python; coding: utf-8; indent-tabs-mode: nil; tab-width: 4 -*-
### BEGIN LICENSE
# Copyright (C) 2012 Marcio Diaz <marcio.diaz@gmail.com>
# This program is free software: you can redistribute it and/or modify it 
# under the terms of the GNU General Public License version 3, as published 
# by the Free Software Foundation.
# 
# This program is distributed in the hope that it will be useful, but 
# WITHOUT ANY WARRANTY; without even the implied warranties of 
# MERCHANTABILITY, SATISFACTORY QUALITY, or FITNESS FOR A PARTICULAR 
# PURPOSE.  See the GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License along 
# with this program.  If not, see <http://www.gnu.org/licenses/>.
### END LICENSE

import gdata.youtube
import gdata.youtube.service
import re


def PrintEntryDetails(entry):
    entry_format = {}
    entry_format['title'] = entry.media.title.text
    entry_format['url'] = entry.media.player.url
    p = re.compile('=[\w,_,-]+')
    video_id = p.search(entry.media.player.url).group()
    entry_format['videoid'] = video_id[1:] 
    return entry_format

def PrintVideoFeed(feed):
    feed_format = []
    for i in range(len(feed.entry)):
        d = PrintEntryDetails(feed.entry[i])
        d['id'] = i
        feed_format.append(d)
    return feed_format

def SearchAndPrint(search_terms):
    yt_service = gdata.youtube.service.YouTubeService()
    query = gdata.youtube.service.YouTubeVideoQuery()
    query.vq = search_terms
    query.racy = 'include'
    feed = yt_service.YouTubeQuery(query)
    return PrintVideoFeed(feed)


